package dev.fyloz.musicplayer.core.factory

import dev.fyloz.musicplayer.core.http.auth.AuthorizationData
import dev.fyloz.musicplayer.core.model.Track

class TrackFactoryProxy {
    private val factories = mutableMapOf<String, TrackFactory>()

    fun registerFactory(type: String, factory: TrackFactory) {
        factories[type] = factory;
    }

    suspend fun search(query: String, auth: AuthorizationData) =
        factories.values.map { it.searchTrack(query, auth) }.flatten()

    suspend fun createTrack(type: String, id: String, trackId: String, auth: AuthorizationData): Track =
        getFactory(type).createTrack(id, trackId, auth)

    private fun getFactory(type: String) = factories[type]!!;
}
